<template lang="pug">
div
  .row.items-stretch
    .col-auto.q-mb-md
      .column.items-center.full-height
        .col
          q-toggle(v-model='slides.visible', @input='updateVisible()')
        .col-auto
          q-btn(@click='prev', outline, round, icon='chevron_left')
        .col-auto
          .text-center.q-my-sm {{ currentSlide }} of {{ totalSlides }}
        .col-auto
          q-btn(, @click='next', round, icon='chevron_right', color='positive')
    .col-auto
      .scaled_wrap.relative-position(:style='{ height: `${height * ratioNum}px`, width: `${width * ratioNum}px` }')
        .absolute-top-right.z-max.q-mr-xs
          q-badge Current
        .scaled(:style='{ height: `${height}px`, width: `${width}px`, transform: `scale(${ratioNum})` }')
          transition(
            mode='out-in',
            enter-active-class='animate__animated animate__fadeIn animate__fast',
            leave-active-class='animate__animated animate__fadeOut animate__fast'
          )
            Markdown(
              :content='currentslidecontent',
              :sequenceinputs='sequenceinputs',
              :meetinginputs='meetinginputs',
              :key='currentslidecontent'
            )
    .col-auto.q-pl-sm
      .scaled_wrap.relative-position(:style='{ height: `${height * ratioNum}px`, width: `${width * ratioNum}px` }')
        .absolute-top-right.z-max.q-mr-xs
          q-badge Next
        .scaled(:style='{ height: `${height}px`, width: `${width}px`, transform: `scale(${ratioNum})` }')
          transition(
            mode='out-in',
            enter-active-class='animate__animated animate__fadeIn animate__fast',
            leave-active-class='animate__animated animate__fadeOut animate__fast'
          )
            Markdown(
              :content='nextslide',
              :sequenceinputs='sequenceinputs',
              :meetinginputs='meetinginputs',
              :key='nextslide'
            ) 
    .col
      .row
        .col-auto
          q-tabs.q-ml-sm(v-model='tabs', vertical, dense)
            q-tab(
              v-for='(input, index) in getInputs',
              :key='input.field',
              :label='index + 1',
              :name='index',
              icon='edit'
            )
            q-tab(:name='"annotation"', v-if='slides.annotation', icon='notes')
        .col
          q-tab-panels.bg-transparent(v-model='tabs')
            q-tab-panel.q-pl-sm.q-pr-sm.q-pt-none(
              v-for='(input, index) in getInputs',
              :key='input.field',
              :name='index'
            )
              .text-overline {{ input.title }}
              Editor(
                :initialValue='input.type === "s-" ? sequenceinputs[input.field] : meetinginputs[input.field]',
                :options='editoroptions',
                initialEditType='wysiwyg',
                height='205px',
                :ref='`toastuiEditor_${index}`',
                @change='updateField(`toastuiEditor_${index}`, input.field, input.type)'
              )
            q-tab-panel.q-pl-sm.q-pr-sm.q-pt-none(:name='"annotation"', v-if='slides.annotation')
              .text-overline Annotation
              Editor(
                :key='slides.currentslide',
                :initialValue='slides.annotation.type === "sequence" ? sequenceinputs[`_annotation_${slides.annotation.prefix || "*"}_${current.currentSection}_${slides.currentslide}`] : meetinginputs[`_annotation_${current.currentSection}_${slides.currentslide}`]',
                :options='editoroptions',
                initialEditType='wysiwyg',
                height='205px',
                ref='toastuiEditor',
                @change='updateField("toastuiEditor", slides.annotation.type === "sequence" ? `_annotation_${slides.annotation.prefix || "*"}_${current.currentSection}_${slides.currentslide}` : `_annotation_${current.currentSection}_${slides.currentslide}`, slides.annotation.type === "sequence" ? "s-" : "")'
              )
</template>

<script>
import Markdown from './Markdown.vue';
import '@toast-ui/editor/dist/toastui-editor.css';
import { Editor } from '@toast-ui/vue-editor';

let regex = /^:::\s(s-)?(\w*):(.*)$/gm;

export default {
  name: 'Dashboard',
  props: {
    firebase: {
      required: true,
    },
    context: {
      required: false,
    },
  },
  components: {
    Markdown,
    Editor,
  },
  data: () => {
    return {
      ratioNum: 0.4,
      slides: {},
      tabs: 'annotation',
      sequenceinputs: {},
      meetinginputs: {},
      current: {},
      editoroptions: {
        usageStatistics: false,
        height: '100px',
        hideModeSwitch: true,
        toolbarItems: [['bold', 'italic', 'ul', 'strike']],
      },
    };
  },
  computed: {
    ratio() {
      return this.slides.ratio || 4.0 / 3.0;
    },
    height() {
      return `${550 / this.ratio}`;
    },
    width() {
      return '550';
    },
    getInputs() {
      try {
        if (!this.slides.content) return;
        //parse current content for input tags:
        let text = this.slides.content[this.slides.currentslide];

        // console.log(text);
        let inputs = [...text.matchAll(regex)];

        return inputs.map(el => {
          // console.log(el);
          return {
            type: el[1] ? el[1] : 'm-',
            field: el[2],
            title: el[3],
          };
        });
      } catch {
        console.log('no slide content');
        return [];
      }
    },
    currentSlide() {
      return this.slides.currentslide + 1;
    },
    totalSlides() {
      return this.slides.content ? this.slides.content.length : 0;
    },
    nextslide() {
      if (this.slides.content && this.slides.content.length > this.slides.currentslide)
        return this.slides.content[this.slides.currentslide + 1];
      else return '';
    },
    currentslidecontent() {
      if (this.slides.content && this.slides.content.length > this.slides.currentslide)
        return this.slides.content[this.slides.currentslide];
      else return '';
    },
  },
  methods: {
    updateField(fieldname, field, type) {
      // console.log(field);
      // console.log(event);
      // console.log(this.$refs);
      // let ref = null;
      let ref = this.$refs[fieldname];
      if (Array.isArray(ref)) ref = ref[0];

      // console.log(`${type}:${field} with ${event}`);
      //write to firebase data node
      //TODO: debounce, and
      if (type === 's-') {
        this.firebase.ref(`sequence/slides/${this.context.sequenceid}/current/${field}`).set(ref.invoke('getMarkdown'));
      } else {
        this.firebase.ref(`data/slides/${this.context.meetingid}/current/${field}`).set(ref.invoke('getMarkdown'));
      }
    },
    async updateVisible() {
      await this.firebase
        .ref(`config/${this.context.meetingid}/current/currentState/plugins/slides/visible`)
        .set(this.slides.visible);
    },
    async save() {
      await this.firebase.ref(`config/${this.context.meetingid}/current/slides`).set(this.slides);
    },
    async next() {
      if (!this.slides.currentslide) {
        this.slides.currentslide = 0;
      }
      if (this.totalSlides > this.slides.currentslide + 1) {
        this.slides.currentslide++;
        await this.firebase
          .ref(`config/${this.context.meetingid}/current/currentState/plugins/slides/currentslide`)
          .set(this.slides.currentslide);
      }
      // console.log(this.getInputs);
      if (this.getInputs.length) this.tabs = 0;
      else this.tabs = 'annotation';
    },
    async prev() {
      this.tabs = 'annotation';
      if (!this.slides.currentslide) {
        this.slides.currentslide = 0;
      }
      if (this.slides.currentslide > 0) {
        this.slides.currentslide--;
        await this.firebase
          .ref(`config/${this.context.meetingid}/current/currentState/plugins/slides/currentslide`)
          .set(this.slides.currentslide);
      }
      if (this.getInputs.length) this.tabs = 0;
      else this.tabs = 'annotation';
    },
  },
  watch: {
    firebase: {
      immediate: true,
      async handler() {
        await this.$rtdbBind('current', this.firebase.ref(`config/${this.context.meetingid}/current`));

        if (this.context.sequenceid)
          await this.$rtdbBind(
            'sequenceinputs',
            this.firebase.ref(`sequence/slides/${this.context.sequenceid}/current`),
          );
        await this.$rtdbBind('meetinginputs', this.firebase.ref(`data/slides/${this.context.meetingid}/current/`));

        this.$rtdbBind(
          'slides',
          this.firebase.ref(`config/${this.context.meetingid}/current/currentState/plugins/slides`),
        );
      },
    },
  },
};
</script>

<style lang="scss">
.ProseMirror.toastui-editor-contents {
  padding: 3px 8px !important;
}

// .toastui-editor-defaultUI-toolbar {
//   height: 32px;
// }

// .toastui-editor-toolbar {
//   height: 32px;
// }

// .toastui-editor-defaultUI-toolbar button {
//   height: 24px;
//   margin-top: 0px;
// }
</style>

<style lang="scss" scoped>
.scaled {
  // width: 550px;
  // background: silver;

  // height: 412px;
  overflow: hidden;
  // transform: scale(0.4);
  transform-origin: top left;
}

.scaled_wrap {
  // width: 219px;
  overflow: hidden;
  // height: 165px;
  border: 1px solid silver;
  border-radius: 5px;
}
</style>